// MQL4&5-code

template <typename T>
class CASTING
{
public:
  template <typename T1>
  static const T Casting( const T1 &Value )
  {
#ifdef TYPETOBYTES_FULL_SLOW
    static const bool IsScript = ((ENUM_PROGRAM_TYPE)::MQLInfoInteger(MQL_PROGRAM_TYPE) == PROGRAM_SCRIPT);
    static bool FirstRun = true;

    T Data = {0};

    if (FirstRun)
    {
      if (IsScript)
      {
        const int handle = ::FileOpen("Casting.tmp", FILE_READ | FILE_WRITE | FILE_BIN);

        if (handle != INVALID_HANDLE)
        {
          ::FileWriteStruct(handle, Value);

          ::FileSeek(handle, 0, SEEK_SET);
          ::FileReadStruct(handle, Data);

          ::FileClose(handle);
        }
      }
      else
      {
        ::Alert("TYPETOBYTES_FULL_SLOW-mode only for Scripts!");

        FirstRun = false;
      }
    }

    return(Data);
#else // TYPETOBYTES_FULL_SLOW
    union CAST
    {
      T1 Value1;
      const T Value2;

      CAST( const T1 &Value)
      {
        this.Value1 = Value; //     
      }
    };

    const CAST Union(Value);

    return(Union.Value2);
#endif // TYPETOBYTES_FULL_SLOW
  }
};

#define _C(A, B) CASTING<A>::Casting(B)
#define _R(A) TYPETOBYTES::Read(A)
#define _W(A) A=TYPETOBYTES::Write(A)
#define _OFFSET(A,B) TYPETOBYTES::Offset(A, A.B)
#define _WRONG_ASSIGN_OPERATOR(A) TYPETOBYTES::IsWrongAssignOperator<A>()

#define EQUAL_DEFINE(A)                 \
  template <typename T1>                \
  bool operator ==( const T1 &A ) const \
  {                                     \
    return(::ArrayCompare(this.Bytes,   \
           _R(Value).Bytes) == 0);      \
  }                                     \
                                        \
  template <typename T1>                \
  bool operator !=( const T1 &A ) const \
  {                                     \
    return(!(this == Value));           \
  }

#define CONSTRUCTOR_DEFINE(A)                                  \
  template <typename T1>                                       \
  T1 operator []( const T1 Pos ) const                         \
  {                                                            \
    STRUCT_TYPE<T1> Res = {0};                                 \
    const int iPos = (int)Pos;                                 \
                                                               \
    if (iPos + sizeof(T1) <= ::ArraySize(this.Bytes))          \
    {                                                          \
      STRUCT_READ<T1> Tmp = {0};                               \
                                                               \
      ::ArrayCopy(Tmp.Bytes, this.Bytes, 0, iPos, sizeof(T1)); \
                                                               \
      Res = _C(STRUCT_TYPE<T1>, Tmp);                          \
    }                                                          \
                                                               \
    return(Res.Value);                                         \
  }                                                            \
                                                               \
  EQUAL_DEFINE(Value)                                          \
  EQUAL_DEFINE(Value[])

struct STRUCT_READ_ARRAY
{
  uchar Bytes[];

  STRUCT_READ_ARRAY( void )
  {
  }

  template <typename T>
  STRUCT_READ_ARRAY( const T &Value[] )
  {
    const int Size = ::ArraySize(Value);
    const int Step = sizeof(T);

    ::ArrayResize(this.Bytes, Size * Step);

    for (int i = 0, j = 0; i < Size; i++, j += Step)
      ::ArrayCopy(this.Bytes, _R(Value[i]).Bytes, j);
  }

  STRUCT_READ_ARRAY( const string &Value[] )
  {
    const int Size = ::ArraySize(Value);

    for (int i = 0, j = 0; i < Size; j += StringLen(Value[i++])/* + 1*/) //    -   
      ::ArrayCopy(this.Bytes, _R(Value[i]).Bytes, j);
  }

  STRUCT_READ_ARRAY( const string &Value )
  {
    ::StringToCharArray(Value, this.Bytes);
  }

  void operator =( const STRUCT_READ_ARRAY &Value )
  {
    ::ArrayCopy(this.Bytes, Value.Bytes);

    return;
  }

  CONSTRUCTOR_DEFINE(STRUCT_READ_ARRAY)
};

template <typename T>
struct STRUCT_TYPE
{
  T Value;

  void operator =( const T& tValue )
  {
    //       T-
    // https://www.mql5.com/ru/forum/1111/page1870#comment_4863733
    this.Set(this, tValue);
  }

  template <typename T1>
  void Set( STRUCT_TYPE<T1> &Struct, const T1 &tValue )
  {
    Struct = _C(STRUCT_TYPE<T1>, tValue);
  }

#define DEFINE_TYPES                                         \
  M(char) M(short) M(int) M(long) M(uchar) M(ushort) M(uint) \
  M(ulong) M(bool) M(double) M(float) M(color) M(datetime)

#define M(A)                                         \
  void Set( STRUCT_TYPE<A> &Struct, const A tValue ) \
  {                                                  \
    Struct.Value = tValue;                           \
  }

  DEFINE_TYPES

#undef M
};

template <typename T>
struct STRUCT_READ
{
  uchar Bytes[sizeof(T)];

  void operator =( const T &Value )
  {
    const STRUCT_TYPE<T> Res = Value;

    this = _C(STRUCT_READ<T>, Res);
  }

  CONSTRUCTOR_DEFINE(STRUCT_READ)
};

#undef CONSTRUCTOR_DEFINE
#undef EQUAL_DEFINE

template <typename T>
struct STRUCT_WRITE
{
  T Data;
  int Pos;

  STRUCT_WRITE( const T &Value )
  {
    this.Data = Value;
    this.Pos = 0;
  }

  STRUCT_WRITE<T> operator []( const int iPos )
  {
    this.Pos = iPos;

    return(this);
  }

  //    return(this)
  void operator =( const STRUCT_WRITE<T> &Value )
  {
    this.Data = Value.Data;
    this.Pos = Value.Pos;

    return;
  }

  //    return(this)
  STRUCT_WRITE( void )
  {
  }

  template <typename T1>
  T1 GetValue( const T1&, const uchar &Array[] ) const
  {
    STRUCT_READ<T1> Res = {0};

    //   , ..  MQL4     
    ::ArrayCopy(Res.Bytes, Array, 0, 0, ::MathMin(::ArraySize(Array), ::ArraySize(Res.Bytes)));

    return(_C(STRUCT_TYPE<T1>, Res).Value);
  }

  string GetValue( const string&, const uchar &Array[] ) const
  {
    return(::CharArrayToString(Array));
  }

#define OPERATOR_DEFINE(A   )                         \
  template <typename T1>                              \
  T operator =( const T1 A ) const                    \
  {                                                   \
    uchar TmpBytes[];                                 \
    ::ArrayCopy(TmpBytes, _R(this.Data).Bytes);       \
                                                      \
    ::ArrayCopy(TmpBytes, _R(Value).Bytes, this.Pos); \
                                                      \
    return(this.GetValue(this.Data, TmpBytes));       \
  }

  OPERATOR_DEFINE(Value)
  OPERATOR_DEFINE(&Value)
  OPERATOR_DEFINE(&Value[])

#undef OPERATOR_DEFINE
};

class TYPETOBYTES
{
private:
  template <typename T>
  static const STRUCT_TYPE<T> FillBytes( const uchar Byte = UCHAR_MAX )
  {
    STRUCT_READ<T> Res = {0};

    ::ArrayInitialize(Res.Bytes, Byte);

    return(_C(STRUCT_TYPE<T>, Res));
  }

public:
#define READ_DEFINE(A, B, C)       \
  static const B Read( const C A ) \
  {                                \
    const B Res = Value;           \
                                   \
    return(Res);                   \
  }

  template <typename T>
  READ_DEFINE(&Value, STRUCT_READ<T>, T)

  template <typename T>
  READ_DEFINE(&Value[], STRUCT_READ_ARRAY, T)

#define M(A) READ_DEFINE(Value, STRUCT_READ<A>, A)

  DEFINE_TYPES

#undef M
#undef READ_DEFINE
#undef DEFINE_TYPES

  static const STRUCT_READ_ARRAY Read( const string Value )
  {
    const STRUCT_READ_ARRAY Res(Value);

    return(Res);
  }

  template <typename T>
  static STRUCT_WRITE<T> Write( const T &Value )
  {
    const STRUCT_WRITE<T> Res(Value);

    return(Res);
  }

  template <typename T>
  static bool IsWrongAssignOperator( void )
  {
    bool Res = (sizeof(T) != 0);

    if (Res)
    {
      STRUCT_TYPE<T> NotNull_Type = TYPETOBYTES::FillBytes<T>();
      STRUCT_TYPE<T> Null_Type = {0};

      T NotNull = NotNull_Type.Value;
      T Null = Null_Type.Value;

      // ,   - https://www.mql5.com/ru/forum/1111/page1874#comment_4871926
      //    - https://www.mql5.com/ru/forum/95447/page3#comment_4872456
      const STRUCT_TYPE<T> constNotNull_Type = NotNull_Type;
      const STRUCT_TYPE<T> constNull_Type = Null_Type;

      const T constNotNull = constNotNull_Type.Value;
      const T constNull = constNull_Type.Value;


      Res = ((_R(Null) != Null_Type.Value) || (_R(NotNull) != NotNull_Type.Value) || (_R(Null) == NotNull) ||
             (_R(constNull) != Null_Type.Value) || (_R(constNotNull) != NotNull_Type.Value) || (_R(constNull) == constNotNull));
    }

    return(Res);
  }

 // Co-author - https://www.mql5.com/ru/users/alximiks
 // Return the first shift of Field bit in the Struct.
  template <typename T1, typename T2>
  static int Offset( T1 &Struct, T2 &Field )
  {
    int Res = -1;

    if (!TYPETOBYTES::IsWrongAssignOperator<T2>())
    {
      const STRUCT_TYPE<T2> StoredField = Field; //  T2- 

      // get Struct where Field value is with all unset bits (0000...)
      const STRUCT_TYPE<T2> Null = {0};
      Field = Null.Value;

      const STRUCT_READ<T1> StructWithUnsetField = _C(STRUCT_READ<T1>, Struct);

      // get Struct where Field value is with all set bits (1111...)
      Field = TYPETOBYTES::FillBytes<T2>().Value;
      const STRUCT_READ<T1> StructWithSetField = _C(STRUCT_READ<T1>, Struct);

      //restore Struct data
      Field = StoredField.Value;

      for (int i = 0; i < sizeof(T1); i++)
        if (StructWithUnsetField.Bytes[i] != StructWithSetField.Bytes[i])
        {
          Res = i;

          break;
        }
    }

    return(Res);
  }

  template <typename T1, typename T2>
  static int Offset( T1 &Struct, T2 &Field[] )
  {
    int Res = -1;

    if (!TYPETOBYTES::IsWrongAssignOperator<T2>())
    {
      const STRUCT_TYPE<T2> StoredField = Field[0]; //  T2- 

      // get Struct where Field value is with all unset bits (0000...)
      const STRUCT_TYPE<T2> Null = {0};
      Field[0] = Null.Value;

      const STRUCT_READ<T1> StructWithUnsetField = _C(STRUCT_READ<T1>, Struct);

      // get Struct where Field value is with all set bits (1111...)
      Field[0] = TYPETOBYTES::FillBytes<T2>().Value;
      const STRUCT_READ<T1> StructWithSetField = _C(STRUCT_READ<T1>, Struct);

      //restore Struct data
      Field[0] = StoredField.Value;

      for (int i = 0; i < sizeof(T1); i++)
        if (StructWithUnsetField.Bytes[i] != StructWithSetField.Bytes[i])
        {
          Res = i;

          break;
        }
    }

    return(Res);
  }
};

//  ArrayCopy
template <typename T1, typename T2>
int _ArrayCopy( T1 &Dst_Array[], const T2 &Src_Array[], const int Dst_Start = 0, const int Src_Start = 0, const int Count = WHOLE_ARRAY )
{
  STRUCT_READ_ARRAY Dst(Dst_Array);

  const int Amount = _WRONG_ASSIGN_OPERATOR(T1) ? 0 : ::ArrayCopy(Dst.Bytes, _R(Src_Array).Bytes, Dst_Start, Src_Start, Count);

  if (Amount > 0)
  {
    const int Step = sizeof(T1);

    const int Size = ::ArraySize(Dst.Bytes);
    ::ArrayResize(Dst_Array, Size / Step + ((Size % Step == 0) ? 0 : 1));

    const int TmpEnd = Dst_Start + Amount;
    const int End = ::MathMin(TmpEnd / Step + ((TmpEnd % Step == 0) ? 1 : 2), ::ArraySize(Dst_Array));

    STRUCT_READ<T1> Tmp;

    for (int i = Dst_Start / Step, j = i * Step; i < End; i++, j += Step)
    {
      ::ArrayCopy(Tmp.Bytes, Dst.Bytes, 0, j, Step);

      Dst_Array[i] = _C(STRUCT_TYPE<T1>, Tmp).Value;
    }
  }

  return(Amount);
}